"use strict";Object.defineProperty(exports, "__esModule", {value: true});











var _chunkC3GKUYHBcjs = require('./chunk-C3GKUYHB.cjs');














var _chunkHJKDVO7Ucjs = require('./chunk-HJKDVO7U.cjs');


var _chunkQT3OZZO4cjs = require('./chunk-QT3OZZO4.cjs');


var _chunkHHZVPIBDcjs = require('./chunk-HHZVPIBD.cjs');

// src/common/bin/index.ts
var BinaryEncoder = class {
  async encode(data) {
    const dataEncoder = _chunkHJKDVO7Ucjs.createBinEncoder.call(void 0, );
    _chunkHJKDVO7Ucjs.writeAny.call(void 0, dataEncoder, data);
    return _chunkHJKDVO7Ucjs.encodeToUint8Array.call(void 0, dataEncoder);
  }
  async decode(data) {
    return _chunkC3GKUYHBcjs.readAny.call(void 0, _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkHHZVPIBDcjs.toUint8Array.call(void 0, data)));
  }
};
function encodeJson(data) {
  const dataEncoder = _chunkHJKDVO7Ucjs.createBinEncoder.call(void 0, );
  _chunkHJKDVO7Ucjs.writeAny.call(void 0, dataEncoder, data);
  return _chunkHJKDVO7Ucjs.encodeToUint8Array.call(void 0, dataEncoder);
}
function decodeJson(data) {
  return _chunkC3GKUYHBcjs.readAny.call(void 0, _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkHHZVPIBDcjs.toUint8Array.call(void 0, data)));
}
function createBinaryStreamEncoder(initialData) {
  const dataEncoder = _chunkHJKDVO7Ucjs.createBinEncoder.call(void 0, );
  if (initialData != null)
    _chunkHJKDVO7Ucjs.writeUint8Array.call(void 0, dataEncoder, _chunkHHZVPIBDcjs.toUint8Array.call(void 0, initialData));
  return {
    /** Just writes the bytes. Length is not stored! */
    writeBytes: (data, expectedLength) => {
      const bin = _chunkHHZVPIBDcjs.toUint8Array.call(void 0, data);
      _chunkQT3OZZO4cjs.assertCondition.call(void 0, !(expectedLength != null && bin.length !== expectedLength), `Expected ${expectedLength} bytes, got ${bin.length}`);
      _chunkHJKDVO7Ucjs.writeUint8Array.call(void 0, dataEncoder, bin);
    },
    writeBytesVar: (data) => _chunkHJKDVO7Ucjs.writeVarUint8Array.call(void 0, dataEncoder, _chunkHHZVPIBDcjs.toUint8Array.call(void 0, data)),
    writeUintVar: (data) => _chunkHJKDVO7Ucjs.writeVarUint.call(void 0, dataEncoder, data),
    writeUint8: (data) => _chunkHJKDVO7Ucjs.writeUint8.call(void 0, dataEncoder, data),
    writeUint16: (data) => _chunkHJKDVO7Ucjs.writeUint16.call(void 0, dataEncoder, data),
    writeUint32: (data) => _chunkHJKDVO7Ucjs.writeUint32.call(void 0, dataEncoder, data),
    writeIntVar: (data) => _chunkHJKDVO7Ucjs.writeVarInt.call(void 0, dataEncoder, data),
    writeFloat: (data) => _chunkHJKDVO7Ucjs.writeFloat32.call(void 0, dataEncoder, data),
    writeStringVar: (data) => _chunkHJKDVO7Ucjs.writeVarString.call(void 0, dataEncoder, data),
    write: (data) => _chunkHJKDVO7Ucjs.writeAny.call(void 0, dataEncoder, data),
    getUint8Array: () => _chunkHJKDVO7Ucjs.encodeToUint8Array.call(void 0, dataEncoder),
    getLength: () => _chunkHJKDVO7Ucjs.length.call(void 0, dataEncoder)
  };
}
function createBinaryStreamDecoder(data) {
  const dataDecoder = _chunkC3GKUYHBcjs.createDecoder.call(void 0, _chunkHHZVPIBDcjs.toUint8Array.call(void 0, data));
  return {
    readBytes: (len) => _chunkC3GKUYHBcjs.readUint8Array.call(void 0, dataDecoder, len),
    readBytesVar: () => _chunkC3GKUYHBcjs.readVarUint8Array.call(void 0, dataDecoder),
    readUintVar: () => _chunkC3GKUYHBcjs.readVarUint.call(void 0, dataDecoder),
    readUint8: () => _chunkC3GKUYHBcjs.readUint8.call(void 0, dataDecoder),
    readUint16: () => _chunkC3GKUYHBcjs.readUint16.call(void 0, dataDecoder),
    readUint32: () => _chunkC3GKUYHBcjs.readUint32.call(void 0, dataDecoder),
    readIntVar: () => _chunkC3GKUYHBcjs.readVarInt.call(void 0, dataDecoder),
    readFloat: () => _chunkC3GKUYHBcjs.readFloat32.call(void 0, dataDecoder),
    readStringVar: () => _chunkC3GKUYHBcjs.readVarString.call(void 0, dataDecoder),
    read: () => _chunkC3GKUYHBcjs.readAny.call(void 0, dataDecoder),
    getOffset: () => dataDecoder.pos || 0
  };
}
function bitfield(bitfield2 = 0) {
  return {
    setBit: (bit, value = true) => value ? bitfield2 |= 1 << bit : bitfield2 &= ~(1 << bit),
    unsetBit: (bit) => bitfield2 &= 1 << bit,
    toggleBit: (bit) => bitfield2 ^= 1 << bit,
    getBit: (bit) => (bitfield2 & 1 << bit) !== 0,
    getValue: () => bitfield2
  };
}
async function blobToArrayBuffer(blob) {
  return await blob.arrayBuffer();
}
async function blobToUint8Array(blob) {
  const buffer = await blobToArrayBuffer(blob);
  if (buffer != null)
    return _chunkHHZVPIBDcjs.toUint8Array.call(void 0, buffer);
}










exports.BinaryEncoder = BinaryEncoder; exports.encodeJson = encodeJson; exports.decodeJson = decodeJson; exports.createBinaryStreamEncoder = createBinaryStreamEncoder; exports.createBinaryStreamDecoder = createBinaryStreamDecoder; exports.bitfield = bitfield; exports.blobToArrayBuffer = blobToArrayBuffer; exports.blobToUint8Array = blobToUint8Array;
//# sourceMappingURL=chunk-NAJQQ6BN.cjs.map